function setup()
    -- Make sure to require this project to allow mouse support. For now it seems to only support Modern Codea might make one for legacy if people ask.
    
    -- Here is the mouse class Properties majority of the property are read only anything with "(can set/write)" can be assigned
    --[=[
        mouse.active: boolean   -- checks if a mouse is active
        mouse.connected: function()         --callback (can set/write) 
        mouse.disconnected: function()      --callback (can set/write) 
        #mouse: number                      -- number of mice connected
        mouse.version: number               -- the version the mice class is on
    
        mouse.interval: number                  -- time between clicks (can set/write)
        mouse.defaultInterval: number           -- default time between click set to 0.25
        
        mouse.x: number
        mouse.y: number
        mouse.position: vec2
    
        mouse.inRegion: boolean -- checks if the mouse is in the app window/viewer.
    
        mouse.left: mouse.button
        mouse.right: mouse.button
        mouse.middle: mouse.button
    
        mouse.button: (Example: mouse.left.released)
        pressing: boolean               -- check if mouse currently pressed
        value:number                    -- same as pressing but it is a number
        pressed:boolean                 -- check if the mouse got first press
        released:boolean                -- check if the mouse got first release
        click: boolean                  -- check if there was a single click
        doubleClick: boolean            -- check if there was a double click
        tripleClick: boolean            -- check if there was a triple click
        numClicks: number               -- check how many consecutive clicks there was
        timePressing: number            -- gets the how long the mouse has been pressed currently
        timeReleasing: number           -- gets the how long the mouse has been released currently
        timeLastPressed: number         -- gets the time it was pressed before releasing (currently releasing)
        timeLastReleased: number        -- gets the time it was pressed before pressing (currently pressing)
        
    
        mouse.scroll: vec2
    
        mouse.hide()            -- hides the mouse
        mouse.show()            -- shows the mouse
        mouse.hidden: boolean   -- checks if mouse is hidden
    
        mouse.lock: boolean     -- Locks the pointer (can set/write)
            
        -- These are not working in this version will be fixed soon
        mouse.dx                -- change in x
        mouse.dy                -- change in y
    ]=]
    
    --mouse.connected = function() print("Connected") end
    --mouse.disconnected = function() print("Disconnected") end
    --print(mouse)
end

function draw()
    -- IMPORTANT: MAKE SURE TO COMMENT THESE CODE BACK ELSE YOUR PROJECT WILL CRASH
    
    --print(mouse.active)
    --print("x:", mouse.x, "y:", mouse.y)
    --print(mouse.scroll.x)
    --print(mouse.inRegion)
    --print("Scroll?:",mouse.scroll)
    --mouse.hide()
    --print("Position:", mouse.position) 
    --print("Hidden:", mouse.hidden)
    
    --print(mouse.right.timeLastPressed)

    --[=[if mouse.left.tripleClick then
        print("Triple Left Click")
    end]=]
    --[=[
    if mouse.right.doubleClick then
        print("Double Right Click")
    end
    ]=]
    --[=[
    if mouse.middle.click then
        print("Middle Click")
    end
    ]=]
    --[=[
    if mouse.left.numClicks >= 1 then
        print("Number of Left Clicks: "..mouse.left.numClicks)
    end
    ]=]
    
    --print(#mouse)
    --print("Left Mouse Pressed:",mouse.left.pressed)
    --print("Right Mouse Released:",mouse.right.released)
    --print("Middle Mouse Pressing:",mouse.middle.pressing)
    --print("Left Time Pressing:", mouse.left.timePressing)
    --print("Right Time Releasing:", mouse.right.timeReleasing)
    --print("Middle Time Last Pressed:", mouse.middle.timeLastPressed)
    --print("Middle Time Last Released:", mouse.middle.timeLastReleased)
    --print("Value of Left Mouse", mouse.left.value)
    --print("Value of Right Mouse", mouse.right.value)
    
    
    -- Pointer Lock
    --mouse.lock = true
    --print("Mouse in Region?:", mouse.inRegion)
    --print("dx:",mouse.dx, " dy:", mouse.dy) 
end

